unit _Creature;

interface

	uses
   	_Global, _Species;

	type
   	PCreature = ^ TCreature;
    TCreature = Object
    private
      Dir : TDirection;
      Spc : PSpecies;
      Step : Integer;
    public
      constructor Init (TheSpc : PSpecies; TheDir : TDirection; N : Integer);
      procedure Draw (X, Y : Integer; Highlight : Boolean);
      function  Direction : PDirection;
      function  Species : PSpecies;
      function  DoInstruction (Flag : Integer) : Integer;
    end;

implementation

uses
  Graph;

constructor TCreature.Init;
begin
  Dir := TheDir;
  Spc := TheSpc;
  Step := N;
end;

function  TCreature.Direction;
begin
  Direction := @Dir;
end;

function  TCreature.Species;
begin
  Species := Spc;
end;

function  TCreature.DoInstruction;
var
 Command, Data : Integer;

begin
  while True do
  begin
	  Command := Spc^.Command(Step);
    Inc(Step);
   	Data := Command shr 8;
    if (Command and Go = Go) then
      {Go to another command}
      Step := Data
    else if (Command and IfRandom = IfRandom) then
    begin
      {do random}
      if (Random(2) = 0) then Step := Data;
    end
    else if (Command and IfEnemy = IfEnemy) then
    begin
      {check if there is enemey}
      if (Flag = Enemy) then Step := Data;
    end
    else if (Command and IfSame = IfSame) then
    begin
      {if front is same}
      if (Flag = Same) then Step := Data;
    end
    else if (Command and IfWall = IfWall) then
    begin
      {if wall}
      if (Flag = Wall) then Step := Data;
    end
    else if (Command and IfEmpty = IfEmpty) then
    begin
      {if empty}
      if (Flag = Empty) then Step := Data;
    end
    else if (Command and ComInfect = ComInfect) then
    begin
      {infect enemey}
      DoInstruction := Infect + Data shl 8;
      Exit;
    end
      {face right}
    else if (Command and ComRight = ComRight) then
    begin
      Dir := (Dir + 1) mod 4;
      DoInstruction := Right;
      Exit;
    end
    else if (Command and ComLeft = ComLeft) then
    begin
      Dir := (Dir + 3) mod 4;
      DoInstruction := Left;
      Exit;
    end
    else if (Command and ComHop = ComHop) then
    begin
      DoInstruction := Hop;
      Exit;
    end;
  end;
end;

procedure TCreature.Draw (X, Y : Integer; HighLight : Boolean);
begin
  PutImage(X, Y, Species^.Icon(Dir)^, NormalPut);
  if Highlight then
  begin
    SetColor(30);
    Rectangle(X+0, Y+0, X + IconSize - 1, Y + IconSize - 1);
    Rectangle(X+1, Y+1, X + IconSize - 2, Y + IconSize - 2);
    SetColor(0);
    Rectangle(X+2, Y+2, X + IconSize - 3, Y + IconSize - 3);
  end;
end;

end.